## org.apache.commons.collections.bag
Class TransformedBag

    java.lang.Object
      org.apache.commons.collections.collection.AbstractCollectionDecorator
          org.apache.commons.collections.collection.AbstractSerializableCollectionDecorator
              org.apache.commons.collections.collection.TransformedCollection
                  org.apache.commons.collections.bag.TransformedBag

All Implemented Interfaces:
  java.io.Serializable, java.lang.Iterable, java.util.Collection, Bag

Direct Known Subclasses:
  TransformedSortedBag

    public class TransformedBag

extends TransformedCollection
implements Bag

Decorates another `Bag` to transform objects that are added.

The add methods are affected by this class. Thus objects must be removed or searched for using their transformed form. For example, if the transformation converts Strings to Integers, you must use the Integer form to remove objects.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne
See Also:
  Serialized Form

Field Summary

Fields inherited from class org.apache.commons.collections.collection.TransformedCollection
`transformer`

Fields inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`collection`

Constructor Summary
`protected` `TransformedBag(Bag bag, Transformer transformer)` Constructor that wraps (not copies).

Method Summary
`boolean` `add(java.lang.Object object, int nCopies)` Adds `nCopies` copies of the specified object to the Bag.
`static Bag` `decorate(Bag bag, Transformer transformer)` Factory method to create a transforming bag.
`protected Bag` `getBag()` Gets the decorated bag.
`int` `getCount(java.lang.Object object)` Returns the number of occurrences (cardinality) of the given object currently in the bag.
`boolean` `remove(java.lang.Object object, int nCopies)` Removes `nCopies` copies of the specified object from the Bag.
`java.util.Set` `uniqueSet()` Returns a `Set` of unique elements in the Bag.

Methods inherited from class org.apache.commons.collections.collection.TransformedCollection
`add, addAll, decorate, transform, transform`

Methods inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`clear, contains, containsAll, equals, getCollection, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.commons.collections.Bag
`add, containsAll, iterator, remove, removeAll, retainAll, size`

Methods inherited from interface java.util.Collection
`addAll, clear, contains, equals, hashCode, isEmpty, toArray, toArray`

Constructor Detail

### TransformedBag

    protected TransformedBag(Bag bag,
                             Transformer transformer)

  Constructor that wraps (not copies).

  If there are any elements already in the bag being decorated, they are NOT transformed.

  Parameters:
    `bag` - the bag to decorate, must not be null
    `transformer` - the transformer to use for conversion, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if bag or transformer is null

Method Detail

### decorate

    public static Bag decorate(Bag bag,
                               Transformer transformer)

  Factory method to create a transforming bag.

  If there are any elements already in the bag being decorated, they are NOT transformed.

  Parameters:
    `bag` - the bag to decorate, must not be null
    `transformer` - the transformer to use for conversion, must not be null
  Returns:
    a new transformed Bag
  Throws:
    `java.lang.IllegalArgumentException` - if bag or transformer is null

### getBag

    protected Bag getBag()

  Gets the decorated bag.

  Returns:
    the decorated bag

### getCount

    public int getCount(java.lang.Object object)

  Description copied from interface: `Bag`
  Returns the number of occurrences (cardinality) of the given object currently in the bag. If the object does not exist in the bag, return 0.

  Specified by:
    `getCount` in interface `Bag`
  Parameters:
    `object` - the object to search for
  Returns:
    the number of occurrences of the object, zero if not found

### remove

    public boolean remove(java.lang.Object object,
                          int nCopies)

  Description copied from interface: `Bag`
  Removes `nCopies` copies of the specified object from the Bag.

  If the number of copies to remove is greater than the actual number of copies in the Bag, no error is thrown.

  Specified by:
    `remove` in interface `Bag`
  Parameters:
    `object` - the object to remove
    `nCopies` - the number of copies to remove
  Returns:
    `true` if this call changed the collection

### add

    public boolean add(java.lang.Object object,
                       int nCopies)

  Description copied from interface: `Bag`
  Adds `nCopies` copies of the specified object to the Bag.

  If the object is already in the `Bag.uniqueSet()` then increment its count as reported by `Bag.getCount(Object)`. Otherwise add it to the `Bag.uniqueSet()` and report its count as `nCopies`.

  Specified by:
    `add` in interface `Bag`
  Parameters:
    `object` - the object to add
    `nCopies` - the number of copies to add
  Returns:
    `true` if the object was not already in the `uniqueSet`

### uniqueSet

    public java.util.Set uniqueSet()

  Description copied from interface: `Bag`
  Returns a `Set` of unique elements in the Bag.

  Uniqueness constraints are the same as those in `Set`.

  Specified by:
    `uniqueSet` in interface `Bag`
  Returns:
    the Set of unique Bag elements

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.